//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <IniFiles.hpp>
#include "App_Common.h"
#include "Moa_AutoPointers.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_common {
//---------------------------------------------------------------------------
const AnsiString TCommon::About = "Execian 3.0.0 Beta 1\r\n\r\nCopyright (C) 2009-2012 Moochos. All rights reserved.";
const AnsiString TCommon::HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString TCommon::SettingsFile = ExtractFilePath(Application->ExeName) + "Settings.ini";
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TSettingsHandler::TSettingsHandler() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandler::~TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TModel::TModel() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TModel::~TModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TSelection::TSelection() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSelection::~TSelection()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TCommands::HandleFeatureUnavailable()
{
	throw EAppError("The feature is unavailable.");
}
//---------------------------------------------------------------------------
__fastcall TCommands::TCommands() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TCommands::~TCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Initialize()
{
	try {
		FList = new TStringList();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Uninitialize()
{
	delete FList;
	FList = NULL;
}
//---------------------------------------------------------------------------
TSettingsHandler* __fastcall TSettingsHandlers::GetItem(int AIndex)
{
	return static_cast<TSettingsHandler*>(List->Objects[AIndex]);
}
//---------------------------------------------------------------------------
int __fastcall TSettingsHandlers::GetCount()
{
	return List->Count;
}
//---------------------------------------------------------------------------
int __fastcall TSettingsHandlers::GetCapacity()
{
	return List->Capacity;
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::SetCapacity(int ACapacity)
{
	List->Capacity = ACapacity;
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandlers::TSettingsHandlers() :
	TObject(),
	FList(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandlers::~TSettingsHandlers()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Add(TSettingsHandler* AItem, const AnsiString& ASection)
{
	List->AddObject(ASection, AItem);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Remove(TSettingsHandler* AItem)
{
	List->Delete(List->IndexOfObject(AItem));
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Clear()
{
	List->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::LoadSettings()
{
	TAutoPointer<TMemIniFile> LSettings = new TMemIniFile(TCommon::SettingsFile);
	for(int LI = 0; LI < Count; ++LI) {
		Items[LI]->LoadSettings(LSettings, List->Strings[LI]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::SaveSettings()
{
	TAutoPointer<TMemIniFile> LSettings = new TMemIniFile(TCommon::SettingsFile);
	for(int LI = 0; LI < Count; ++LI) {
		Items[LI]->SaveSettings(LSettings, List->Strings[LI]);
	}
	LSettings->UpdateFile();
}
//---------------------------------------------------------------------------
} // End namespace App_common
//---------------------------------------------------------------------------

