//---------------------------------------------------------------------------
#ifndef App_DoubleH
#define App_DoubleH
//---------------------------------------------------------------------------
#include "App_Common.h"
//---------------------------------------------------------------------------
namespace App_double {
//---------------------------------------------------------------------------
class EDoubleError : public Exception
{
public:
	__fastcall EDoubleError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class EDoubleFail : public EDoubleError
{
public:
	__fastcall EDoubleFail(const AnsiString& AMessage) : EDoubleError(AMessage) {}
};
//---------------------------------------------------------------------------
enum TSerialNumberPosition
{
	spBeginning,
	spEnd,
};
//---------------------------------------------------------------------------
class TDoubleExecutor : public TObject
{
private:
	AnsiString FSourceFile;
	AnsiString FOutputDirectory;
	AnsiString FOriginalNamePrefix;
	AnsiString FOriginalNameSuffix;
	bool FRemoveExtension;
	bool FAvoidNameCollision;
	AnsiString FSerialNumberPrefix;
	AnsiString FSerialNumberSuffix;
	int FMinSerialNumber;
	int FMaxSerialNumber;
	TSerialNumberPosition FSerialNumberPosition;
	AnsiString FCreatedDirectory;
	void __fastcall Prepare();
	void __fastcall Unprepare();
	AnsiString __fastcall AddOriginalName(const AnsiString& ADirectory);
	AnsiString __fastcall AddSerialNumber(const AnsiString& ADirectory);
	void __fastcall CreateDirectory(const AnsiString& ADirectory);
	void __fastcall Fail();
protected:
public:
	__fastcall TDoubleExecutor();
	virtual __fastcall ~TDoubleExecutor();
	virtual void __fastcall Execute();
	__property AnsiString SourceFile = {read=FSourceFile, write=FSourceFile};
	__property AnsiString OutputDirectory = {read=FOutputDirectory, write=FOutputDirectory};
	__property AnsiString OriginalNamePrefix = {read=FOriginalNamePrefix, write=FOriginalNamePrefix};
	__property AnsiString OriginalNameSuffix = {read=FOriginalNameSuffix, write=FOriginalNameSuffix};
	__property bool RemoveExtension = {read=FRemoveExtension, write=FRemoveExtension};
	__property bool AvoidNameCollision = {read=FAvoidNameCollision, write=FAvoidNameCollision};
	__property AnsiString SerialNumberPrefix = {read=FSerialNumberPrefix, write=FSerialNumberPrefix};
	__property AnsiString SerialNumberSuffix = {read=FSerialNumberSuffix, write=FSerialNumberSuffix};
	__property int MinSerialNumber = {read=FMinSerialNumber, write=FMinSerialNumber};
	__property int MaxSerialNumber = {read=FMaxSerialNumber, write=FMaxSerialNumber};
	__property TSerialNumberPosition SerialNumberPosition = {read=FSerialNumberPosition, write=FSerialNumberPosition};
	__property AnsiString CreatedDirectory = {read=FCreatedDirectory};
};
//---------------------------------------------------------------------------
} // End namespace App_double
using namespace App_double;
//---------------------------------------------------------------------------
#endif

