//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_DoubleOptions.h"
#include "Moa_ShellFiles.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_doubleoptions {
//---------------------------------------------------------------------------
bool __fastcall TDoubleOptions::operator ==(const TDoubleOptions& AOther) const
{
	if(&AOther == this) {
		return true;
	}
	return
		OutputDirectory == AOther.OutputDirectory &&
		OtherOutputDirectory == AOther.OtherOutputDirectory &&
		OriginalNamePrefix == AOther.OriginalNamePrefix &&
		OriginalNameSuffix == AOther.OriginalNameSuffix &&
		(RemoveExtension ? 1 : 0) == (AOther.RemoveExtension ? 1 : 0) &&
		(AvoidNameCollision ? 1 : 0) == (AOther.AvoidNameCollision ? 1 : 0) &&
		SerialNumberPrefix == AOther.SerialNumberPrefix &&
		SerialNumberSuffix == AOther.SerialNumberSuffix &&
		MinSerialNumber == AOther.MinSerialNumber &&
		MaxSerialNumber == AOther.MaxSerialNumber &&
		SerialNumberPosition == AOther.SerialNumberPosition &&
		(SortEntries ? 1 : 0) == (AOther.SortEntries ? 1 : 0);
}
//---------------------------------------------------------------------------
bool __fastcall TDoubleOptions::operator !=(const TDoubleOptions& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TDoubleOptionsModel::SetValue(const TDoubleOptions& AValue)
{
	if(AValue == Value) {
		return;
	}
	FValue = AValue;
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TDoubleOptionsModel::DoChange()
{
	if(OnChange != NULL) {
		OnChange(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TDoubleOptionsModel::TDoubleOptionsModel() :
	TModel(),
	FValue(GetDefaultValue()),
	FOnChange(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TDoubleOptionsModel::~TDoubleOptionsModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TDoubleOptions __fastcall TDoubleOptionsModel::GetDefaultValue()
{
	TDoubleOptions LValue;
	LValue.OutputDirectory = odDesktop;
	LValue.OtherOutputDirectory = TSpecialShellFiles::GetDocuments();
	LValue.OriginalNamePrefix = AnsiString();
	LValue.OriginalNameSuffix = AnsiString();
	LValue.RemoveExtension = true;
	LValue.AvoidNameCollision = true;
	LValue.SerialNumberPrefix = " (";
	LValue.SerialNumberSuffix = ")";
	LValue.MinSerialNumber = 1;
	LValue.MaxSerialNumber = 100;
	LValue.SerialNumberPosition = spEnd;
	LValue.SortEntries = true;
	return LValue;
}
//---------------------------------------------------------------------------
} // End namespace App_doubleoptions
//---------------------------------------------------------------------------

