//---------------------------------------------------------------------------
#ifndef App_DoubleOptionsH
#define App_DoubleOptionsH
//---------------------------------------------------------------------------
#include "App_Double.h"
//---------------------------------------------------------------------------
namespace App_doubleoptions {
//---------------------------------------------------------------------------
enum TOutputDirectoryType
{
	odAtSource,
	odDesktop,
	odAsk,
	odOther,
};
//---------------------------------------------------------------------------
struct TDoubleOptions
{
	TOutputDirectoryType OutputDirectory;
	AnsiString OtherOutputDirectory;
	AnsiString OriginalNamePrefix;
	AnsiString OriginalNameSuffix;
	bool RemoveExtension;
	bool AvoidNameCollision;
	AnsiString SerialNumberPrefix;
	AnsiString SerialNumberSuffix;
	int MinSerialNumber;
	int MaxSerialNumber;
	TSerialNumberPosition SerialNumberPosition;
	bool SortEntries;
	virtual bool __fastcall operator ==(const TDoubleOptions& AOther) const;
	virtual bool __fastcall operator !=(const TDoubleOptions& AOther) const;
};
//---------------------------------------------------------------------------
class TDoubleOptionsModel : public TModel
{
private:
	TDoubleOptions FValue;
	TNotifyEvent FOnChange;
	void __fastcall SetValue(const TDoubleOptions& AValue);
protected:
	virtual void __fastcall DoChange();
public:
	__fastcall TDoubleOptionsModel();
	virtual __fastcall ~TDoubleOptionsModel();
	static TDoubleOptions __fastcall GetDefaultValue();
	__property TDoubleOptions Value = {read=FValue, write=SetValue};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
} // End namespace App_doubleoptions
using namespace App_doubleoptions;
//---------------------------------------------------------------------------
#endif

