//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_OptionsDialog.h"
#include "Moa_Files.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOptionsDialog* OptionsDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Button11Click(TObject* ASender)
{
	AnsiString LDirectory = Edit11->Text;
	if(!SelectDirectory("Choose the output directory.", WideString(), LDirectory)) {
		Abort();
	}
	SetCurrentDir(LDirectory);
	Edit11->Text = LDirectory;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::CheckBox22Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::ComboBox21Exit(TObject* ASender)
{
	Input29;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit11Exit(TObject* ASender)
{
	Input12;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit21Exit(TObject* ASender)
{
	Input21;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit22Exit(TObject* ASender)
{
	Input22;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit23Exit(TObject* ASender)
{
	Input25;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit24Exit(TObject* ASender)
{
	Input26;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit25Exit(TObject* ASender)
{
	Input27;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::Edit26Exit(TObject* ASender)
{
	Input28;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::RadioButton11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::RadioButton12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::RadioButton13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::RadioButton14Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::UpdateAccess()
{
	Edit11->Enabled = RadioButton14->Checked;
	Button11->Enabled = RadioButton14->Checked;
	ComboBox21->Enabled = CheckBox22->Checked;
	Edit23->Enabled = CheckBox22->Checked;
	Edit24->Enabled = CheckBox22->Checked;
	Edit25->Enabled = CheckBox22->Checked;
	Edit26->Enabled = CheckBox22->Checked;
	Label23->Enabled = CheckBox22->Checked;
	Label24->Enabled = CheckBox22->Checked;
	Label25->Enabled = CheckBox22->Checked;
	Label26->Enabled = CheckBox22->Checked;
	Label27->Enabled = CheckBox22->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::HandleInvalidInput(const AnsiString& AMessage, TWinControl* AControl)
{
	ActiveControl = AControl;
	throw EAppError(AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::HandleInvalidValue(const AnsiString& AMessage)
{
	throw EAppError(AMessage);
}
//---------------------------------------------------------------------------
TDoubleOptions __fastcall TOptionsDialog::GetInputs()
{
	TDoubleOptions LInputs;
	LInputs.OutputDirectory = Input11;
	LInputs.OtherOutputDirectory = Input12;
	LInputs.OriginalNamePrefix = Input21;
	LInputs.OriginalNameSuffix = Input22;
	LInputs.RemoveExtension = Input23;
	LInputs.AvoidNameCollision = Input24;
	LInputs.SerialNumberPrefix = Input25;
	LInputs.SerialNumberSuffix = Input26;
	LInputs.MinSerialNumber = Input27;
	LInputs.MaxSerialNumber = Input28;
	LInputs.SerialNumberPosition = Input29;
	LInputs.SortEntries = Input31;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInputs(const TDoubleOptions& AInputs)
{
	Input11 = AInputs.OutputDirectory;
	Input12 = AInputs.OtherOutputDirectory;
	Input21 = AInputs.OriginalNamePrefix;
	Input22 = AInputs.OriginalNameSuffix;
	Input23 = AInputs.RemoveExtension;
	Input24 = AInputs.AvoidNameCollision;
	Input25 = AInputs.SerialNumberPrefix;
	Input26 = AInputs.SerialNumberSuffix;
	Input27 = AInputs.MinSerialNumber;
	Input28 = AInputs.MaxSerialNumber;
	Input29 = AInputs.SerialNumberPosition;
	Input31 = AInputs.SortEntries;
}
//---------------------------------------------------------------------------
TOutputDirectoryType __fastcall TOptionsDialog::GetInput11()
{
	TOutputDirectoryType LInput = odAtSource;
	if(RadioButton11->Checked) {
		LInput = odAtSource;
	}
	else if(RadioButton12->Checked) {
		LInput = odDesktop;
	}
	else if(RadioButton13->Checked) {
		LInput = odAsk;
	}
	else if(RadioButton14->Checked) {
		LInput = odOther;
	}
	else {
		HandleInvalidInput("Choose an item.", RadioButton11);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput11(TOutputDirectoryType AOutputDirectory)
{
	switch(AOutputDirectory) {
	case odAtSource:
		RadioButton11->Checked = true;
		break;
	case odDesktop:
		RadioButton12->Checked = true;
		break;
	case odAsk:
		RadioButton13->Checked = true;
		break;
	case odOther:
		RadioButton14->Checked = true;
		break;
	default:
		HandleInvalidValue("The program does not support the output directory.");
		break;
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOptionsDialog::GetInput12()
{
	AnsiString LInput = Edit11->Text;
	if(!TPathUtilities::IsAbsolute(LInput)) {
		HandleInvalidInput("Type the path in absolute form.", Edit11);
	}
	return Edit11->Text;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput12(const AnsiString& AInput12)
{
	Edit11->Text = AInput12;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOptionsDialog::GetInput21()
{
	AnsiString LInput = Edit21->Text;
	if(TPathUtilities::FindInvalidNameCharacter(LInput) >= 1) {
		HandleInvalidInput("Remove invalid characters.", Edit21);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput21(const AnsiString& AInput21)
{
	Edit21->Text = AInput21;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOptionsDialog::GetInput22()
{
	AnsiString LInput = Edit22->Text;
	if(TPathUtilities::FindInvalidNameCharacter(LInput) >= 1) {
		HandleInvalidInput("Remove invalid characters.", Edit22);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput22(const AnsiString& AInput22)
{
	Edit22->Text = AInput22;
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDialog::GetInput23()
{
	return CheckBox21->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput23(bool AInput23)
{
	CheckBox21->Checked = AInput23;
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDialog::GetInput24()
{
	return CheckBox22->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput24(bool AInput24)
{
	CheckBox22->Checked = AInput24;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOptionsDialog::GetInput25()
{
	AnsiString LInput = Edit23->Text;
	if(TPathUtilities::FindInvalidNameCharacter(LInput) >= 1) {
		HandleInvalidInput("Remove invalid characters.", Edit23);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput25(const AnsiString& AInput25)
{
	Edit23->Text = AInput25;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOptionsDialog::GetInput26()
{
	AnsiString LInput = Edit24->Text;
	if(TPathUtilities::FindInvalidNameCharacter(LInput) >= 1) {
		HandleInvalidInput("Remove invalid characters.", Edit24);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput26(const AnsiString& AInput26)
{
	Edit24->Text = AInput26;
}
//---------------------------------------------------------------------------
int __fastcall TOptionsDialog::GetInput27()
{
	int LInput;
	if(!TryStrToInt(Edit25->Text, LInput) || LInput  < 0 || LInput > StrToInt(Edit26->Text)) {
		HandleInvalidInput("Type an integer between 0 and the maximum.", Edit25);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput27(int AInput27)
{
	Edit25->Text = AInput27;
}
//---------------------------------------------------------------------------
int __fastcall TOptionsDialog::GetInput28()
{
	int LInput;
	if(!TryStrToInt(Edit26->Text, LInput) || LInput < StrToInt(Edit25->Text)) {
		HandleInvalidInput("Type an integer equal to or greater than the minimum.", Edit26);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput28(int AInput28)
{
	Edit26->Text = AInput28;
}
//---------------------------------------------------------------------------
TSerialNumberPosition __fastcall TOptionsDialog::GetInput29()
{
	TSerialNumberPosition LInput = spBeginning;
	switch(ComboBox21->ItemIndex) {
	case 0:
		LInput = spBeginning;
		break;
	case 1:
		LInput = spEnd;
		break;
	default:
		HandleInvalidInput("Choose an item.", ComboBox21);
		break;
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput29(TSerialNumberPosition AInput29)
{
	switch(AInput29) {
	case spBeginning:
		ComboBox21->ItemIndex = 0;
		break;
	case spEnd:
		ComboBox21->ItemIndex = 1;
		break;
	default:
		HandleInvalidValue("The program does not support the position.");
		break;
	}
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDialog::GetInput31()
{
	return CheckBox31->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDialog::SetInput31(bool AInput31)
{
	CheckBox31->Checked = AInput31;
}
//---------------------------------------------------------------------------
__fastcall TOptionsDialog::TOptionsDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(TDoubleOptionsModel::GetDefaultValue())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TOptionsDialog::~TOptionsDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TOptionsDialog* __fastcall TOptionsDialog::EnsureCreated()
{
	if(OptionsDialog == NULL) {
		OptionsDialog = new TOptionsDialog(Application);
	}
	return OptionsDialog;
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDialog::Execute()
{
	ActiveControl = NULL;
	SelectFirst();
	Inputs = Values;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------


