//----------------------------------------------------------------------------
#ifndef App_ProgramDialogH
#define App_ProgramDialogH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <FileCtrl.hpp>
#include <StdCtrls.hpp>
#include "App_Programs.h"
//---------------------------------------------------------------------------
class TProgramDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TButton* Button3;
	TButton* Button4;
	TCheckBox* CheckBox1;
	TComboBox* ComboBox1;
	TEdit* Edit1;
	TEdit* Edit2;
	TEdit* Edit3;
	TEdit* Edit4;
	TEdit* Edit5;
	TLabel* Label1;
	TLabel* Label2;
	TLabel* Label3;
	TLabel* Label4;
	TLabel* Label5;
	TLabel* Label6;
	TOpenDialog* OpenDialog1;
	void __fastcall Button1Click(TObject* ASender);
	void __fastcall Button2Click(TObject* ASender);
	void __fastcall ComboBox1Exit(TObject* ASender);
	void __fastcall Edit1Exit(TObject* ASender);
	void __fastcall Edit2Exit(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TProgramEntry* FValues;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall UpdateInputs();
	void __fastcall UpdateValues();
	void __fastcall HandleInvalidValue(const AnsiString& AMessage);
	void __fastcall HandleInvalidInput(const AnsiString& AMessage, TWinControl* AControl);
	AnsiString __fastcall GetInput1();
	void __fastcall SetInput1(const AnsiString& AInput);
	AnsiString __fastcall GetInput2();
	void __fastcall SetInput2(const AnsiString& AInput);
	AnsiString __fastcall GetInput3();
	void __fastcall SetInput3(const AnsiString& AInput);
	AnsiString __fastcall GetInput4();
	void __fastcall SetInput4(const AnsiString& AInput);
	AnsiString __fastcall GetInput5();
	void __fastcall SetInput5(const AnsiString& AInput);
	int __fastcall GetInput6();
	void __fastcall SetInput6(int AInput);
	bool __fastcall GetInput7();
	void __fastcall SetInput7(bool AInput);
	__property AnsiString Input1 = {read=GetInput1, write=SetInput1};
	__property AnsiString Input2 = {read=GetInput2, write=SetInput2};
	__property AnsiString Input3 = {read=GetInput3, write=SetInput3};
	__property AnsiString Input4 = {read=GetInput4, write=SetInput4};
	__property AnsiString Input5 = {read=GetInput5, write=SetInput5};
	__property int Input6 = {read=GetInput6, write=SetInput6};
	__property bool Input7 = {read=GetInput7, write=SetInput7};
protected:
public:
	__fastcall TProgramDialog(TComponent* AOwner);
	virtual __fastcall ~TProgramDialog();
	static TProgramDialog* __fastcall EnsureCreated();
	virtual bool __fastcall Execute();
	virtual void __fastcall Reset();
	__property TProgramEntry* Values = {read=FValues, write=FValues};
};
//----------------------------------------------------------------------------
extern PACKAGE TProgramDialog* ProgramDialog;
//----------------------------------------------------------------------------
#endif

