//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ProgressDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProgressDialog* ProgressDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult != mrOk) {
		ACanClose = false;
		DoCancel();
	}
	else {
		ACanClose = true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ContinueButtonClick(TObject* ASender)
{
	DoContinue();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoContinue()
{
	if(OnContinue != NULL) {
		OnContinue(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::TProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FOnContinue(NULL),
	FOnCancel(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::~TProgressDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TProgressDialog* __fastcall TProgressDialog::EnsureCreated()
{
	if(ProgressDialog == NULL) {
		ProgressDialog = new TProgressDialog(Application);
	}
	return ProgressDialog;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Execute()
{
	ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Finish()
{
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowParameters(const AnsiString& AProgram, const AnsiString& ADocument)
{
	ProgramLabel->Caption = AProgram;
	DocumentLabel->Caption = ADocument;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowInformation(const AnsiString& AMessage)
{
	InformationImage->Visible = true;
	WarningImage->Visible = false;
	ErrorImage->Visible = false;
	MessageLabel->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowWarning(const AnsiString& AMessage)
{
	InformationImage->Visible = false;
	WarningImage->Visible = true;
	ErrorImage->Visible = false;
	MessageLabel->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowError(const AnsiString& AMessage)
{
	InformationImage->Visible = false;
	WarningImage->Visible = false;
	ErrorImage->Visible = true;
	MessageLabel->Caption = AMessage;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::ShowProgress(int ACurrent, int AAll)
{
	ProgressBar->Min = 0;
	ProgressBar->Max = AAll;
	ProgressBar->Position = ACurrent;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Reset()
{
	ShowParameters(AnsiString(), AnsiString());
	ShowInformation(AnsiString());
	ShowProgress(0, 100);
}
//---------------------------------------------------------------------------

